"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const statuses_1 = __importDefault(require("statuses"));
const CustomError_1 = __importDefault(require("./CustomError"));
class HttpAbstractError {
    crateError({ code, additionalProps, message }) {
        const msg = message || statuses_1.default.message[code];
        const key = statuses_1.default.message[code].toLowerCase().replace(/ /g, "_");
        const error = new CustomError_1.default(Object.assign({ message: msg, statusCode: code, errorKey: key }, additionalProps));
        return error;
    }
    NextError(code, next, attrs) {
        if (!next)
            throw new Error("Cannot access HttpError functions till adding the initializer middleware");
        const _a = attrs || {}, { message } = _a, additionalProps = __rest(_a, ["message"]);
        const error = this.crateError({ additionalProps, code, message });
        return next(error);
    }
}
exports.default = HttpAbstractError;
//# sourceMappingURL=AbstractError.js.map