import { ErrorAttrs } from "../types";
export default class CustomError extends Error implements ErrorAttrs {
    statusCode: number | string;
    errorKey?: string;
    description?: string;
    invalidParams?: {
        message: string;
        location?: string;
        param: string;
    }[];
    help?: string;
    message: string;
    constructor({ statusCode, invalidParams, message, description, errorKey, help }: ErrorAttrs);
}
